package com.appboxo.appboxo_sdk

import android.app.Activity
import android.util.Log
import androidx.annotation.NonNull
import com.appboxo.sdk.Appboxo
import com.appboxo.sdk.Config
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

public class AppboxoSdkPlugin(private val activity: Activity) : MethodCallHandler {

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        when (call.method) {
            "setConfig" -> {
                val clientId = call.argument<String>("client_id")!!
                Appboxo.setConfig(Config.Builder()
                        .setClientId(clientId)
                        .build())
            }
            "openMiniApp" -> {
                val appId = call.argument<String>("app_id")!!
                val payload = call.argument<String>("payload")!!
                Appboxo.createMiniApp(appId, payload).open(activity)
            }
        }
    }

    companion object {
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val channel = MethodChannel(registrar.messenger(), "appboxo_sdk")
            Appboxo.init(registrar.activity().application)
            channel.setMethodCallHandler(AppboxoSdkPlugin(registrar.activity()))
        }
    }
}
