import Flutter
import UIKit
import AppBoxoSDK

public class SwiftAppboxoSdkPlugin: NSObject, FlutterPlugin {
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "appboxo_sdk", binaryMessenger: registrar.messenger())
        let instance = SwiftAppboxoSdkPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        
        switch call.method {
        case "setConfig":
            guard let arguments = call.arguments as? [String : Any] else { return }
            let clientId = arguments["client_id"] as? String ?? ""
            AppBoxo.shared.setConfig(config: Config(clientId: clientId))
        case "openMiniApp":
            guard let arguments = call.arguments as? [String : Any] else { return }
            let appId = arguments["app_id"] as? String ?? ""
            let payload = arguments["payload"] as? String ?? ""
            let miniApp = AppBoxo.shared.createMiniApp(appId: appId, payload: payload)
            miniApp.open(viewController: UIApplication.shared.delegate!.window!!.rootViewController!)
            break
        default:
            break
        }
    }
}
